import xmpp
from xmpp import cli
import config
from BotClass import JabberBot
import json
#раскомментировать, когда перейдем на разные пароли
import hashlib
from datetime import datetime

#test
import jsonAndRequest as jsreq

global tasklist

#В этом файле содержится только то, что запускает конкретный обработчик

# botname="open_strequest_assigned"
botname="open_template_bot"
#botname="test"
JID=botname+"@"+config.JSERVER
#JID=f"{botname}@msg.sharix-app.org"
#PASSWORD=config.PASSWORD
PORT=config.PORT

#раскомментировать, когда перейдем на разные пароли
PASSWORD=hashlib.md5((botname+config.PASSWORD).encode('utf-8')).hexdigest()
#PASSWORD="test1234@"

print(JID, PASSWORD)

#таким образом хранится список jid, от которых можно получать сообщения этому боту
listen_to=["test@ej.sharix-app.org", "test1@ej.sharix-app.org"]

#тут хранится список jid, кому бот может отправлять сообщения в результате обработки заявки
process_to=["test@ej.sharix-app.org", "test1@ej.sharix-app.org"]

# обработчик входящих сообщений
def message_handler(conn, mess):
    text = mess.getBody()#текст сообщения боту
    user = mess.getFrom()#отправитель сообщения
    #user = mess.getNode()#только jid 
    #example json to object user
    if text is not None:
        """ example json
            {
                "name":"Cristian", 
                "address":
                {
                    "street":"Sesame",
                    "number":122
                }
            }
        """
   
   #нужна проверка, данный обработчик вообще должен от данного отправителя получать сообщения или нет. Подсказка ниже
    print (str(user).split("/")[0])
    if (str(user).split("/")[0]) in listen_to:
        print(text)
        print(mess)

        if text is not None:
            orderObj = jsreq.jsonToUser(text)
            tasklist.append(orderObj)
            bot.bot_log(str(datetime.now())+" Поступивший заказ успешно добавлен в очередь обработки\n")


def open_bot_template():
    #print("Тут описывается работа со списком задач в данном статусе")
    for i in range(len(tasklist)):
        #проверяем элемент tasklist[i]
        bot.bot_log(botname + " " + datetime.now().strftime('%Y-%m-%d') + " " + str(i) + " " + "Заказ в очереди на обработке\n")
        print ("TASKLIST", tasklist[i])
        
        if (tasklist[i].address.number==122):
            bot.fake_api_call(tasklist[i].name)
            
            #он тут вроде не валится, но сообщения не приходят вроде
            bot.proceed_status("test@ej.sharix-app.org",tasklist[i])
            
            del tasklist[i]
            bot.bot_log(botname+" "+str(datetime.now())+" "+str(i)+" "+"Заказ успешно обработан и удален из очереди\n")
            print (tasklist)
        else:
            bot.bot_log(botname+" "+str(datetime.now())+" "+str(i)+" "+"Заказ оставлен в очереди\n")

#Авторизация и запуск бота

#пустой список заказов
tasklist = []

bot = JabberBot(JID, PASSWORD, PORT)

#загружаем список заказов для обработки из базы (по идее, сюда попадаем в случае первого запуска или перезапуска)
bot.fake_api_call("Получаем список заказов по названию бота-обработчика")

bot.register_handler('message', message_handler)
bot.start(open_bot_template)



